# Class VulkanMappedMemoryRange.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanMappedMemoryRange.Builder

Enclosing class:
  `VulkanMappedMemoryRange`

public static final class VulkanMappedMemoryRange.Builder extends Object
Builds instances of type `VulkanMappedMemoryRange`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanMappedMemoryRange`
  `build()`
  Builds a new `VulkanMappedMemoryRange`.
  `final VulkanMappedMemoryRange.Builder`
  `from(VulkanMappedMemoryRangeType instance)`
  Fill a builder with attribute values from the provided `VulkanMappedMemoryRangeType` instance.
  `final VulkanMappedMemoryRange.Builder`
  `setMemory(VulkanDeviceMemoryType memory)`
  Initializes the value for the `memory` attribute.
  `final VulkanMappedMemoryRange.Builder`
  `setOffset(long offset)`
  Initializes the value for the `offset` attribute.
  `final VulkanMappedMemoryRange.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanMappedMemoryRange.Builder from(VulkanMappedMemoryRangeType instance)
    Fill a builder with attribute values from the provided `VulkanMappedMemoryRangeType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMemory

    public final VulkanMappedMemoryRange.Builder setMemory(VulkanDeviceMemoryType memory)
    Initializes the value for the `memory` attribute.
    Parameters:
      `memory` - The value for memory
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VulkanMappedMemoryRange.Builder setOffset(long offset)
    Initializes the value for the `offset` attribute.
    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanMappedMemoryRange.Builder setSize(long size)
    Initializes the value for the `size` attribute.
    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanMappedMemoryRange build()
    Builds a new `VulkanMappedMemoryRange`.
    Returns:
      An immutable instance of VulkanMappedMemoryRange
    Throws:
      `IllegalStateException` - if any required attributes are missing